function [X,para]=ComputeNonLocalTV(B, lambda,para);

[Ny,Nx] = size(B); % image size
Im0=B;
Min1 = min(Im0(:)); Max1 = max(Im0(:));
Im0 = ( Im0-Min1 )/ ( Max1-Min1 ); % noisy image
B=Im0;


YES = 0;NO = 1;
% parameters for Weight function
m = 7; % patch size
w = 9; % window search size
h = (0.25)^2; % scale parameter for weight function
NbNeigh = 5; % number of neighbors
includeCloseNeigh = YES; % include 4 closest neighbors
includeCloseNeigh = NO;
VecParametersW = [ Ny; Nx; m; w; h; NbNeigh; includeCloseNeigh; ];

% parameters for Split-Bregman Nonlocal TV

lambdaInv = lambda; %  
lambda = 1/lambdaInv;
mu = 5*lambda; % 
nbIters = 1; % nomber of outer iterations
NbInnerIter = 1; % number of inner iterations
VecParametersNLTV = [ Ny; Nx; m; w; NbNeigh; lambda; mu;...
    nbIters; NbInnerIter; includeCloseNeigh;];

% if isempty(W)
%     W=zeros([size(B),NbNeigh*4]);
    
% end

if para.flag==1
%     [W,Y,SY] = compute_fastNLWeights_mex(single(B),single(VecParametersW));
%     [W,Y,SY] = compute_fastNLWeights_mexb2(single(B),single(VecParametersW));
    VecParametersW=[VecParametersW; 1 ];
    [W,Y,SY] = mexNLweights(single(B), single(VecParametersW));
    para.W=W; para.Y=Y; para.SY=SY;
else
    W=para.W; Y=para.Y; SY=para.SY;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Perform NL-TV
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initialization
NbNeigh2 = VecParametersNLTV(5);
includeCloseNeigh2 = VecParametersNLTV(10);
if includeCloseNeigh2==YES; i=4; else; i=0; end
d = zeros(Nx,Ny,2*(NbNeigh2+i));
b = zeros(Nx,Ny,2*(NbNeigh2+i));
u = B;

[u_new,d_new,b_new,Temp] = SBNLTV_mex(single(u),single(d),single(b),...
    single(B),single(W),int32(Y),int32(SY),single(VecParametersNLTV));
X=u_new*( Max1-Min1 )+Min1;
tmpa=sum(W,3); index=find(tmpa==0);
X(index)=B(index);
X=double(X);
return